Bug 513635 - fuzzing vfat file system appears to cause lock problems
Summary: fuzzing vfat file system appears to cause lock problems
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 12
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Kernel Maintainer List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-07-24 15:24 UTC by Steve Grubb
Modified: 2010-12-05 06:41 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-12-05 06:41:05 UTC
Type: ---


Attachments (Terms of Use)
image reproducing latest crash (1.41 MB, application/octet-stream)
2009-07-24 15:24 UTC, Steve Grubb
no flags Details

Description Steve Grubb 2009-07-24 15:24:10 UTC
Created attachment 355043 [details]
image reproducing latest crash

Description of problem:
running fsfuzz against vfat file system yields debug messages in syslog.

Version-Release number of selected component (if applicable):
kernel-2.6.31-0.81.rc3.git4

Steps to Reproduce:
1. ./run_last

Actual results:
The following scrolls one for a very long time. Just giving a small sample.

Jul 24 10:59:18 livestrong kernel: FAT: Filesystem error (dev loop0)
Jul 24 10:59:18 livestrong kernel:    invalid access to FAT (entry 0x0000d200)
Jul 24 10:59:18 livestrong kernel: attempt to access beyond end of device
Jul 24 10:59:18 livestrong kernel: loop0: rw=0, want=53792, limit=2880
Jul 24 10:59:19 livestrong kernel: FAT: Filesystem error (dev loop0)
Jul 24 10:59:19 livestrong kernel:    invalid access to FAT (entry 0x00000cb7)
Jul 24 10:59:38 livestrong kernel: x25/0x60
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8113edd4>] put_super+0x46/0x6d
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8114028e>] deactivate_super+0x7e/0x9c
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81157919>] mntput_no_expire+0xd0/0x125
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81157fd3>] sys_umount+0x2f8/0x33d
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81012f42>] system_call_fastpath+0x16/0x1b
Jul 24 10:59:38 livestrong kernel:   [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:
Jul 24 10:59:38 livestrong kernel:   ... acquired at:
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810954b4>] __lock_acquire+0xa79/0xc0e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81095737>] lock_acquire+0xee/0x12e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814f3497>] _spin_lock+0x45/0x8e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8114f6f3>] shrink_dcache_memory+0x79/0x1b7
Jul 24 10:59:38 livestrong kernel:   [<ffffffff811053b8>] shrink_slab+0xf2/0x17c
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81105bc8>] kswapd+0x4f2/0x67f
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8107f339>] kthread+0xa5/0xad
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8101412a>] child_rip+0xa/0x20
Jul 24 10:59:38 livestrong kernel:   [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:
Jul 24 10:59:38 livestrong kernel:   -> (&sem->wait_lock){....-.} ops: 0 {
Jul 24 10:59:38 livestrong kernel:      IN-RECLAIM_FS-W at:
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff81094d62>] __lock_acquire+0x327/0xc0e
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff81095737>] lock_acquire+0xee/0x12e
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff814f366a>] _spin_lock_irqsave+0x5d/0xab
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff8126fa41>] __down_read_trylock+0x29/0x77
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff81084116>] down_read_trylock+0x25/0x71
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff8114f747>] shrink_dcache_memory+0xcd/0x1b7
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff811053b8>] shrink_slab+0xf2/0x17c
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff81105bc8>] kswapd+0x4f2/0x67f
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff8107f339>] kthread+0xa5/0xad
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffff8101412a>] child_rip+0xa/0x20
Jul 24 10:59:38 livestrong kernel:                                 [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:      INITIAL USE at:
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff81094d7a>] __lock_acquire+0x33f/0xc0e
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff81095737>] lock_acquire+0xee/0x12e
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff814f366a>] _spin_lock_irqsave+0x5d/0xab
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff8126f9c9>] __down_write_trylock+0x29/0x78
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff81083fa6>] down_write_nested+0x69/0xac
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff8113f6d9>] sget+0x2cc/0x435
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff8113fe90>] get_sb_single+0x45/0xcb
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff811a47ce>] sysfs_get_sb+0x2b/0x41
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff8113fc59>] vfs_kern_mount+0xb2/0x152
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff8113fd25>] kern_mount_data+0x2c/0x42
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff818318a7>] sysfs_init+0x6c/0xe0
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff8182fa81>] mnt_init+0xad/0x1ab
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff8182f569>] vfs_caches_init+0x119/0x140
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff81808061>] start_kernel+0x3ef/0x44c
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff818072d0>] x86_64_start_reservations+0xbb/0xd6
Jul 24 10:59:38 livestrong kernel:                             [<ffffffff818073f0>] x86_64_start_kernel+0x105/0x128
Jul 24 10:59:38 livestrong kernel:                             [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:    }
Jul 24 10:59:38 livestrong kernel:    ... key      at: [<ffffffff824ace18>] __key.18160+0x0/0x28
Jul 24 10:59:38 livestrong kernel:   ... acquired at:
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810954b4>] __lock_acquire+0xa79/0xc0e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81095737>] lock_acquire+0xee/0x12e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814f366a>] _spin_lock_irqsave+0x5d/0xab
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8126fa41>] __down_read_trylock+0x29/0x77
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81084116>] down_read_trylock+0x25/0x71
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8114f747>] shrink_dcache_memory+0xcd/0x1b7
Jul 24 10:59:38 livestrong kernel:   [<ffffffff811053b8>] shrink_slab+0xf2/0x17c
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81105bc8>] kswapd+0x4f2/0x67f
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8107f339>] kthread+0xa5/0xad
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8101412a>] child_rip+0xa/0x20
Jul 24 10:59:38 livestrong kernel:   [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:  ... acquired at:
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810954b4>] __lock_acquire+0xa79/0xc0e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81095737>] lock_acquire+0xee/0x12e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814f3497>] _spin_lock+0x45/0x8e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81171457>] set_dentry_child_flags+0x37/0x115
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81171615>] inotify_add_watch+0xe0/0x117
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810bd934>] audit_add_watch+0x204/0x377
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810bc466>] audit_receive_filter+0x55b/0x8ec
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810ba8e5>] audit_receive+0x68f/0xa87
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81457ee1>] netlink_unicast+0x134/0x1b1
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814581ec>] netlink_sendmsg+0x28e/0x2b1
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814230d1>] __sock_sendmsg+0x70/0x8f
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81423a9d>] sock_sendmsg+0xdb/0x108
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814249d6>] sys_sendto+0x110/0x152
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81012f42>] system_call_fastpath+0x16/0x1b
Jul 24 10:59:38 livestrong kernel:   [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:  ... acquired at:
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810954b4>] __lock_acquire+0xa79/0xc0e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81095737>] lock_acquire+0xee/0x12e
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814f366a>] _spin_lock_irqsave+0x5d/0xab
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810fdd26>] get_page_from_freelist+0x369/0x714
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810fe264>] __alloc_pages_nodemask+0x193/0x5f3
Jul 24 10:59:38 livestrong kernel:   [<ffffffff811292dd>] alloc_pages_current+0xa8/0xc8
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8112ffcc>] alloc_slab_page+0x2e/0x4f
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81130053>] new_slab+0x66/0x201
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81130739>] __slab_alloc+0x227/0x3f0
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81130ee3>] kmem_cache_alloc+0xcb/0x18a
Jul 24 10:59:38 livestrong kernel:   [<ffffffff8126ac14>] idr_pre_get+0x40/0x98
Jul 24 10:59:38 livestrong kernel:   [<ffffffff811712cc>] inotify_handle_get_wd+0x38/0x8c
Jul 24 10:59:38 livestrong kernel:   [<ffffffff811715a7>] inotify_add_watch+0x72/0x117
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810c2a9c>] tag_chunk+0x7d/0x3dc
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810c32f0>] audit_add_tree_rule+0x141/0x26b
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810bc4b2>] audit_receive_filter+0x5a7/0x8ec
Jul 24 10:59:38 livestrong kernel:   [<ffffffff810ba8e5>] audit_receive+0x68f/0xa87
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81457ee1>] netlink_unicast+0x134/0x1b1
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814581ec>] netlink_sendmsg+0x28e/0x2b1
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814230d1>] __sock_sendmsg+0x70/0x8f
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81423a9d>] sock_sendmsg+0xdb/0x108
Jul 24 10:59:38 livestrong kernel:   [<ffffffff814249d6>] sys_sendto+0x110/0x152
Jul 24 10:59:38 livestrong kernel:   [<ffffffff81012f42>] system_call_fastpath+0x16/0x1b
Jul 24 10:59:38 livestrong kernel:   [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:
Jul 24 10:59:38 livestrong kernel:  -> (audit_filter_mutex){+.+.+.} ops: 0 {
Jul 24 10:59:38 livestrong kernel:     HARDIRQ-ON-W at:
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81094d03>] __lock_acquire+0x2c8/0xc0e
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81095737>] lock_acquire+0xee/0x12e
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff814f16bb>] __mutex_lock_common+0x5b/0x3bf
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff814f1b42>] mutex_lock_nested+0x4f/0x6b
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff810bca7e>] audit_update_lsm_rules+0x3d/0x243
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81237eed>] aurule_avc_callback+0x26/0x3c
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81225098>] avc_ss_reset+0xdb/0x11b
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff8123ab0c>] security_load_policy+0x101/0x3e5
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff8122f0c7>] sel_write_load+0xbc/0x650
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff8113d011>] vfs_write+0xbd/0x12e
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff8113d174>] sys_write+0x59/0x91
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81012f42>] system_call_fastpath+0x16/0x1b
Jul 24 10:59:38 livestrong kernel:                            [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:     SOFTIRQ-ON-W at:
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81094d24>] __lock_acquire+0x2e9/0xc0e
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81095737>] lock_acquire+0xee/0x12e
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff814f16bb>] __mutex_lock_common+0x5b/0x3bf
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff814f1b42>] mutex_lock_nested+0x4f/0x6b
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff810bca7e>] audit_update_lsm_rules+0x3d/0x243
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81237eed>] aurule_avc_callback+0x26/0x3c
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81225098>] avc_ss_reset+0xdb/0x11b
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff8123ab0c>] security_load_policy+0x101/0x3e5
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff8122f0c7>] sel_write_load+0xbc/0x650
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff8113d011>] vfs_write+0xbd/0x12e
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff8113d174>] sys_write+0x59/0x91
Jul 24 10:59:38 livestrong kernel:                            [<ffffffff81012f42>] system_call_fastpath+0x16/0x1b
Jul 24 10:59:38 livestrong kernel:                            [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:     RECLAIM_FS-ON-W at:
Jul 24 10:59:38 livestrong kernel:     RECLAIM_FS-ON-W at:
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff81093afb>] mark_held_locks+0x65/0x99
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff81093bec>] lockdep_trace_alloc+0xbd/0xf5
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff81130a9e>] kmem_cache_alloc_node+0x48/0x1b1
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff8142d768>] __alloc_skb+0x5a/0x195
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff810b9057>] audit_make_reply+0x6b/0xe6
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff810bc368>] audit_receive_filter+0x45d/0x8ec
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff810ba8e5>] audit_receive+0x68f/0xa87
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff81457ee1>] netlink_unicast+0x134/0x1b1
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff814581ec>] netlink_sendmsg+0x28e/0x2b1
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff814230d1>] __sock_sendmsg+0x70/0x8f
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff81423a9d>] sock_sendmsg+0xdb/0x108
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff814249d6>] sys_sendto+0x110/0x152
Jul 24 10:59:38 livestrong kernel:                               [<ffffffff81012f42>] system_call_fastpath+0x16/0x1b
Jul 24 10:59:38 livestrong kernel:                               [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:     INITIAL USE at:
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff81094d7a>] __lock_acquire+0x33f/0xc0e
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff81095737>] lock_acquire+0xee/0x12e
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff814f16bb>] __mutex_lock_common+0x5b/0x3bf
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff814f1b42>] mutex_lock_nested+0x4f/0x6b
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff810bca7e>] audit_update_lsm_rules+0x3d/0x243
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff81237eed>] aurule_avc_callback+0x26/0x3c
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff81225098>] avc_ss_reset+0xdb/0x11b
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff8123ab0c>] security_load_policy+0x101/0x3e5
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff8122f0c7>] sel_write_load+0xbc/0x650
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff8113d011>] vfs_write+0xbd/0x12e
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff8113d174>] sys_write+0x59/0x91
Jul 24 10:59:38 livestrong kernel:                           [<ffffffff81012f42>] system_call_fastpath+0x16/0x1b
Jul 24 10:59:38 livestrong kernel:                           [<ffffffffffffffff>] 0xffffffffffffffff
Jul 24 10:59:38 livestrong kernel:   }

Comment 1 Bug Zapper 2009-11-16 11:06:16 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 2 Bug Zapper 2010-11-04 10:41:40 UTC
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 3 Bug Zapper 2010-12-05 06:41:05 UTC
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.